<?php

/**

 * jUpgrade

 *

 * @version		  $Id: migrate_modules.php 21266 2011-05-02 20:09:40Z maguirre $

 * @package		  MatWare

 * @subpackage	com_jupgrade

 * @author      Matias Aguirre <maguirre@matware.com.ar>

* @link        http://www.matware.com.ar

 * @copyright		Copyright 2006 - 2011 Matias Aguire. All rights reserved.

 * @license		  GNU General Public License version 2 or later; see LICENSE.txt

 */
/**

 * Upgrade class for modules

 *

 * This class takes the modules from the existing site and inserts them into the new site.

 *

 * @since	0.4.5

 */
class jUpgradeModules extends jUpgrade

{

	/**

	 * @var		string	The name of the source database table.

	 * @since	0.4.5

	 */

	protected $source = '#__modules';
	/**

	 * Get the mapping of the old positions to the new positions in the template.

	 *

	 * @return	array	An array with keys of the old names and values being the new names.

	 * @since	0.5.7

	 */

	public static function getPositionsMap()

	{

		$map = array(

			// Old	=> // New

			/*'search'				=> 'position-0',

			'top'					=> 'position-1',

			'breadcrumbs'			=> 'position-2',

			'left'					=> 'position-6',

			'right'					=> 'position-7',

			'search'				=> 'position-8',

			'footer'				=> 'position-9',

			'header'				=> 'position-15'*/

		);
		return $map;

	}
	/**

	 * A hook to be able to modify params prior as they are converted to JSON.

	 *

	 * @param	object	$object	A reference to the parameters as an object.

	 *

	 * @return	void

	 * @since	1.0.3

	 * @throws	Exception

	 */

	protected function convertParamsHook(&$object)

	{

		if (isset($object->startLevel)) $object->startLevel++;

		if (!empty($object->endLevel)) $object->endLevel++;

	}
	/**

	 * Get the raw data for this part of the upgrade.

	 *

	 * @return	array	Returns a reference to the source data array.

	 * @since	0.4.5

	 * @throws	Exception

	 */

	protected function &getSourceData()

	{
		$select = "`id` AS `sid`, `title`, `content`, `ordering`, `position`,"

						." `checked_out`, `checked_out_time`, `published`, `module`,"

						." `access`, `showtitle`, `params`, `client_id`";
		$where = array();

		$where[] = "client_id != 1";

		

		$query = 'SELECT distinct module FROM #__modules';

		

		$jupgrade = new jUpgrade;

		

		$jupgrade->db_old->setQuery($query);

		$moduels = $jupgrade->db_old->loadObjectList();

		

		$where_con = '';

		foreach($moduels as $moduel){

			$moduel->module;

			

			$where_con .= " '".$moduel->module."', ";

		}

		

		

		$where_con = substr($where_con,0,-2);

		

		

		//$where[] = "module IN ('mod_breadcrumbs', 'mod_footer', 'mod_mainmenu', 'mod_related_items', 'mod_stats', 'mod_wrapper', 'mod_archive', 'mod_custom', 'mod_latestnews', 'mod_mostread', 'mod_search', 'mod_syndicate', 'mod_banners', 'mod_feed', 'mod_login', 'mod_newsflash', 'mod_random_image', 'mod_whosonline', 'mod_s5_box' , 'mod_s5_accordion_menu' , 'mod_s5_vertical_accordion' , 'mod_s5_tabshow' )";

		

		//echo "<br/>";

		

		$where[] = "module IN ( ".$where_con." )";

		

		//exit;

		

		

		

		$rows = parent::getSourceData(

			$select,

		  null,

			$where,

			'id'

		);

		
		
		

		foreach ($rows as $key=>$row)

		{

			if ($row['module'] == "mod_newsflash") {

				//unset($rows[$key]);

			}

		}

		

		
		// Set up the mapping table for the old positions to the new positions.

		$map = self::getPositionsMap();

		$map_keys = array_keys($map);
		// Getting the component parameter with global settings

		$params = $this->getParams();
		// Do some custom post processing on the list.

		foreach ($rows as &$row)

		{

			$row['params'] = $this->convertParams($row['params']);
			## Fix title

			$row['title'] = str_replace("'", "&#39;", $row['title']);
			## Fix access

			$row['access'] = $row['access']+1;
			## Language

			$row['language'] = "*";
			## Module field changes

			if ($row['module'] == "mod_mainmenu") {

				$row['module'] = "mod_menu";

			}

			else if ($row['module'] == "mod_archive") {

				$row['module'] = "mod_articles_archive";

			}

			else if ($row['module'] == "mod_latestnews") {

				$row['module'] = "mod_articles_latest";

				$parmArray = json_decode($row['params']);

				foreach($parmArray as $key=>$value){

					

					$parmArray->$key= "$value" ;

					if($key == 'show_front' || $key == 'secid' || $key == 'catid'  ){

						unset($parmArray->$key);

					}

					

				}

				$parmArray->show_featured = "";

				$parmArray->layout = "_:default";

				$parmArray->cachemode = "_:static";

				$row['params'] = json_encode($parmArray);

			

			

			}

			else if ($row['module'] == "mod_mostread") {

				$row['module'] = "mod_articles_popular";

			}

			else if ($row['module'] == "mod_newsflash") {

				$row['module'] = "mod_articles_news";

				$row['params'] = str_replace('vert','vertical',$row['params']);

				$parmArray = json_decode($row['params']);

				foreach($parmArray as $key=>$value){

					

					if($key != 'layout'){

						$parmArray->$key= "$value" ;

					}

					if($key == 'show_front' || $key == 'secid' || $key == 'catid'  ){

						unset($parmArray->$key);

					}

					

					if($key == 'catid' ){

						$query = "SELECT section  FROM {$this->config_old['prefix']}categories  WHERE id = ".$value;

						$this->db_old->setQuery($query);

						$cat = $this->db_old->loadObject();

						$catId = $cat->section;

					}

					if( $key == 'readmore' || $key == 'items'  ){

						unset($parmArray->$key);

					}

				}				$parmArray->catid= '***['.'"'.$catId.'"'.']***' ;				$parmArray->item_heading = "h4";

				$parmArray->count = "5";

				$parmArray->ordering = "a.publish_up";

				$parmArray->cachemode = "itemid";
				$row['params'] = str_replace("\\",'',json_encode($parmArray));

				$row['params'] = str_replace("\"***",'',$row['params']);

				$row['params'] = str_replace("***\"",'',$row['params']);
			}else if ($row['module'] == "mod_breadcrumbs") {				$parmArray = json_decode($row['params']);

				foreach($parmArray as $key=>$value){

					$parmArray->$key= "$value" ;

				}

				$parmArray->layout = "_:default";

				$parmArray->cache_time = "900";

				$parmArray->cachemode = "itemid";

				$row['params'] = json_encode($parmArray);

					

			}else if ($row['module'] == "mod_s5_accordion_menu") {				$parmArray = json_decode($row['params']);

				foreach($parmArray as $key=>$value){

					$parmArray->$key= "$value" ;

					

					if($key == 'parentlinks' || $key == 'menu_images' || $key == 'menu_images_align' || $key == 'menu_images_link'  ){

						unset($parmArray->$key);

					}

					

					if($key == 'menutype' && $value =='' ){

						$query = "SELECT *  FROM {$this->config_old['prefix']}menu_types ";

						$this->db_old->setQuery($query);

						$menu = $this->db_old->loadObject();

						$parmArray->$key= "$menu->menutype" ;

					}

				}

				$parmArray->startLevel = "1";

				$parmArray->endLevel = "0";

				$parmArray->class_sfx = "";

				$parmArray->window_open = "";

				$parmArray->layout = "_:default";

				$parmArray->cache = "1";

				$parmArray->cache_time = "900";

				$parmArray->cachemode = "itemid";

				$row['params'] = json_encode($parmArray);					

			}else{

				$parmArray = json_decode($row['params']);

				foreach($parmArray as $key=>$value){

					$parmArray->$key= "$value" ;

				}

				$row['params'] = json_encode($parmArray);

			}

			

			

			

			

			

			

			

			
			## Change positions

			if ($params->positions == 0) {

				if (in_array($row['position'], $map_keys)) {

						$row['position'] = $map[$row['position']];

				}

			}	
		}

		
	
		return $rows;

	}
	/**

	 * Sets the data in the destination database.

	 *

	 * @return	void

	 * @since	0.4.

	 * @throws	Exception

	 */

	protected function setDestinationData()

	{

		// Get the source data.
		
		
		
		$query = 'DELETE FROM  j16_modules WHERE id IN (1, 16, 17, 18)';

		$jupgrade = new jUpgrade;
		
		$jupgrade->db_new->setQuery($query);

		$jupgrade->db_new->Query();
		
		
		

		$rows	= $this->getSourceData();

		$table	= empty($this->destination) ? $this->source : $this->destination;
		// 

		foreach ($rows as $row)

		{

			// Convert the array into an object.

			$row = (object) $row;
			// Get old id 

			$oldlist = new stdClass();

			$oldlist->old = $row->sid;

			unset($row->sid);
			if (!$this->db_new->insertObject($table, $row)) {

				throw new Exception($this->db_new->getErrorMsg());

			}
			// Get new id 

			$oldlist->new = $this->db_new->insertid();
			// Save old and new id

			if (!$this->db_new->insertObject('#__jupgrade_modules', $oldlist)) {

				throw new Exception($this->db_new->getErrorMsg());

			}
		}

	}
}
/**

 * Upgrade class for modules menu

 *

 * This class takes the modules from the existing site and inserts them into the new site.

 *

 * @since	0.4.5

 */

class jUpgradeModulesMenu extends jUpgrade

{

	/**

	 * @var		string	The name of the source database table.

	 * @since	0.4.5

	 */

	protected $source = '#__modules_menu AS m';
	/**

	 * @var		string	The name of the destination database table.

	 * @since	0.4.5

	 */

	protected $destination = '#__modules_menu';
	/**

	 * Get the raw data for this part of the upgrade.

	 *

	 * @return	array	Returns a reference to the source data array.

	 * @since	0.4.5

	 * @throws	Exception

	 */

	protected function &getSourceData()

	{
		
		// Getting the map id's for modules and menus

		$modules = $this->getMapList('modules');

		$menus = $this->getMapList('menus');
		
		

		// Getting the menus keys to prevent 'Notice: Undefined index'

		$menus_keys = array_keys($menus);

		$menus_keys[] = '0';
		
		
		

		$where = "m.moduleid NOT IN ( 1, 16, 17, 18)  and m.menuid in (select id from jos_menu  ) or m.menuid = 0 ";  //

		// Getting the data

		$rows = parent::getSourceData(

			'*',

		  null,

			$where,

			'm.moduleid'

		);

		// Do some custom post processing on the list.
		
				
		
		foreach ($rows as $key=>&$row)
		{	
			
			/*echo $row['moduleid'];
			echo "<br/>";
			if($row['moduleid'] == 58){
				//echo  $row['moduleid'];
				exit;
			}*/
		
			
			
		
			if (in_array($row['menuid'], $menus_keys)) {
			
				$moduleid_new = isset($modules[$row['moduleid']]->new) ? $modules[$row['moduleid']]->new : '';
		
				if(isset($menus[$row['menuid']]->new)){
						
						if($row['menuid']=='0'){
							$menuid_new = '0';
						}else{
							$menuid_new = $menus[$row['menuid']]->new;
						}
						
						if(trim($moduleid_new) != '' && trim($menuid_new) !=''  ){							
							$moduleid_new = $moduleid_new == '' ? 0 : $moduleid_new;							
							$menuid_new  = $menuid_new == '' ? 0 : $menuid_new;
							//if($moduleid_new == 30){
								
										//echo "<b> MODULE ID:</b> {$moduleid_new} <==> <b> MENU ID:</b> {$menuid_new}";
										//echo "<br>.................<br><br>";
							//}
							if($moduleid_new!= 0 ){
														
								$row['moduleid'] = $moduleid_new ;
			
								$row['menuid'] = $menuid_new;
							}		
							
						}
				}else if($row['menuid'] == '0'){
				//echo "else";							$moduleid_new = trim($moduleid_new) == '' ? 0 : $moduleid_new;
							//	echo "<b> MODULE ID:</b> {$moduleid_new} <==> <b> MENU ID:</b> {$row['menuid']}";
							//	echo "<br>.................<br><br>";							
							
							$row['moduleid'] = $moduleid_new ;
		
							$row['menuid'] = $row['menuid'] ;		
							
							if($key == 100 ){
								exit('tstest');
						}					
				}else{
				if($key == 100 ){
								exit('tstest');
						}		
					//echo "unset";
					unset($rows[$key]);
				}

			}
			
		}
		
		//exit;

		$rows1 = $rows ;

		foreach ($rows as $key=>$value){
			foreach ($rows1 as $key1=>$value1){
					
						//$tem = 0 ;
						
						if($value['moduleid'] == $value1['moduleid'] && $value['menuid'] ==  $value1['menuid'] && $key != $key1  ){
							//$tem++;
							//if($tem == 2){
								unset($rows [$key1] );
								$tem = 0;
								break;
							//}

 
						}
						if($value1['moduleid'] == 0 && $value1['menuid'] ==  0 ){
							unset($rows [$key1] );
						}
						
					
			}
		}
		
		return $rows;

	}

}